// CommTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CommTest.h"
#include "CommTestDlg.h"

#include "RS232Interface.h"
#include "RS485Interface.h"
#include "GPIBInterface.h"
#include "TCPInterface.h"
#include "DemoInterface.h"

#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommTestDlg dialog

CCommTestDlg::CCommTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCommTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCommTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pIOInterface = NULL;
}

CCommTestDlg::~CCommTestDlg()
{
	if(m_pIOInterface)
		delete m_pIOInterface;
}

void CCommTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommTestDlg)
	DDX_Control(pDX, IDC_RESPONSE, c_Response);
	DDX_Control(pDX, IDC_COMMAND, c_Command);
	//}}AFX_DATA_MAP

	DDX_Control(pDX, IDC_TERMINATOR, c_Terminator);
	DDX_Control(pDX, IDC_COM_PORT, c_ComPort);
	DDX_Control(pDX, IDC_BAUD_RATE, c_BaudRate);

	DDX_Control(pDX, IDC_CONNECTED, c_ConnectionStatus);
}

BEGIN_MESSAGE_MAP(CCommTestDlg, CDialog)
	//{{AFX_MSG_MAP(CCommTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SEND, OnSend)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COM_PORT, &CCommTestDlg::OnChangeIOSettings)
	ON_CBN_SELCHANGE(IDC_BAUD_RATE, &CCommTestDlg::OnChangeIOSettings)
	ON_CBN_SELCHANGE(IDC_TERMINATOR, &CCommTestDlg::OnChangeIOSettings)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommTestDlg message handlers

BOOL CCommTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	ConnectDisconnectIO(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCommTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCommTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCommTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCommTestDlg::OnSend() 
{
   CWaitCursor wait;
   CString command = "";
   CString response = "";


   //get our command to send
   c_Command.GetWindowText(command);

   //make sure we append a terminator
	int term = c_Terminator.GetCurSel();
	if(term == 0)
		command += "\r";
	else if(term == 1)
		command += "\n";
	else if(term == 2)
		command += "\r\n";
	else
		command += "\r";

   //create our communications object
	
	
	ConnectDisconnectIO(true);

   if(m_pIOInterface)
   {
      if(m_pIOInterface->SendReceiveBuffer(command, response))
      {
         //yippy, it worked
         c_Response.SetWindowText(response);
      }
      else
      {
         //huh?!?, it didn't work
         c_Response.SetWindowText("No Response, command failed!");
			ConnectDisconnectIO(false);
      }

   }

   //highlight the command so they can just start typing a new one.
   c_Command.SetFocus();
   c_Command.SetSel(0, -1, TRUE);

}


CChamberInterface* CCommTestDlg::NewIOInterface()
{
	CChamberInterface* pRet = NULL;
	
	int comm_type = 0;

	CString strComPort = "COM1";
	int iBaudRate = 19200;
	int iTerm = 0;

	//get our current settings

	CString temp;
	int i = c_BaudRate.GetCurSel();
	c_BaudRate.GetLBText(i, temp);
	iBaudRate = atoi(temp);

	i = c_ComPort.GetCurSel();
	c_ComPort.GetLBText(i, temp);
	strComPort = temp;


	iTerm = c_Terminator.GetCurSel();

  pRet = new CRS232Interface(strComPort, iBaudRate);

	OnChangeIOSettings();

	return pRet;
}

void CCommTestDlg::OnChangeInterface() 
{
}



void CCommTestDlg::OnChangeIOSettings()
{
	ConnectDisconnectIO(false);
}

void CCommTestDlg::ConnectDisconnectIO(bool bConnect)
{
	if(bConnect)
	{
		if(!m_pIOInterface)
		{
			m_pIOInterface = NewIOInterface();
		}
		c_ConnectionStatus.SetWindowTextA("Connected");
	}
	else
	{
		if(m_pIOInterface)
		{
			delete m_pIOInterface;
			m_pIOInterface = NULL;
		}
		c_ConnectionStatus.SetWindowTextA("Disconnected");
	}
}